<template>
    <div 
        @drop="onDropOrder($event)"
        @dragenter="onDragEnterOrder"
        @dragover.prevent
        @dragleave="onDragLeaveOrder"
        class="card deliveries home__part"
        :class="{'droping': dropEvent.isEnter}"
    >
        <div class="card__header">
            <h2 class="card__title">Отгрузки</h2>
            <UpdateButton className="deliveries__update" @update="updateDeliveries" />
        </div>
        <div class="card__content deliveries__content">
            <ul v-if="deliveries.list.length" class="deliveries__list list">
                <DeliveryItem
                @remove="remove"
                @start-drag="onDragStartDelivery"
                @stop-drag="onDragEndDelivery"
                v-for="(delivery, i) in deliveries.list"
                :key="i"
                :delivery="delivery" />
            </ul>
            <AppLoader v-else-if="deliveries.isLoading" />
            <div v-else class="deliveries__empty">В данный момент отгрузок нет</div>
            <div v-if="isAddingNewOrder" class="card card--primary pt-"></div>
            <div
                v-if="dragEvent.isStart"
                @drop="onDropDelivery($event)"
                class="card pt-sm card--danger card--outline"
                @dragenter="onDragEnterRemove"
                @dragover.prevent
                @dragleave="onDragLeaveRemove"
                :class="{'droping': dragEvent.isEnter, 'dragged': dragEvent.isStart}"
            >
                Отменить отгрузку
            </div>
        </div>
    </div>
</template>

<script>
import UpdateButton from '../Buttons/UpdateButton';
import DeliveryItem from './DeliveryItem';
import AppLoader from '../AppLoader';

export default {
    components: {
        UpdateButton, DeliveryItem, AppLoader
    },
    data() {
        return {
            deliveries: {
                isLoading: false,
                list: []
            },
            dragEvent: {
                isStart: false,
                isEnter: false
            },
            dropEvent: {
                type: 'remove',
                isEnter: false,
            },
            isAddingNewOrder: false,
            FETCH_URL: 'https://demo-api.vsdev.space/api/orders_admin/20210603/'
        }
    },
    methods: {
        async updateDeliveries() {
            this.deliveries.list = [];
            this.deliveries.isLoading = true;

            const URL = 'https://demo-api.vsdev.space/api/orders_admin/20210603/deliveries';
            
            let response = await fetch(URL);
            if (response.ok) {
                this.deliveries.list = await response.json();
                this.deliveries.isLoading = false;
            } else {
                setTimeout(this.updateDeliveries, 5000);
            }
        },

        async remove(id) {
            const URL = this.FETCH_URL + 'deliveries/' + id;

            await fetch(URL, {
                method: 'DELETE'
            });
            
            const index = this.deliveries.list.findIndex(element => element.id == id);
            this.deliveries.list.splice(index, 1);
        },

        async orderToDelivery(id) {
            const URL = this.FETCH_URL + 'orders/' + id + '/delivery';
            this.isAddingNewOrder = true;

            try {
                let response = await fetch(URL, {
                    method: 'POST'
                });

                if (!response.ok) console.log('error');
            } catch {
                console.log('error');
            }

            this.isAddingNewOrder = false;
        },

        async onDropOrder(event) {
            const type = event.dataTransfer.getData('itemType');
            const id = event.dataTransfer.getData('itemID');

            if (type === 'delivery') return;
            
            await this.orderToDelivery(id);
            await this.updateDeliveries();
            this.dropEvent.isEnter = false;
        },

        async onDropDelivery(event) {
            const type_ = event.dataTransfer.getData('itemType');
            if (type_ !== 'delivery') return; 

            const id = event.dataTransfer.getData('itemID');
            await this.remove(id);

            this.dropEvent.isEnter = false;
        },

        onDragEnterOrder() {           
            this.dropEvent.isEnter = true;
        },

        onDragLeaveOrder() {
            this.dropEvent.isEnter = false;
        },

        onDragEndOrder() {
            this.dropEvent.isEnter = false;
        },

        onDragStartDelivery(event, delivery) {
            event.dataTransfer.setData('itemID', delivery.id);
            event.dataTransfer.setData('itemType', 'delivery');
            this.dragEvent.isStart = true;
        },

        onDragEnterDelivery() {
            this.dragEvent.isEnter = true;
        },

        onDragLeaveDelivery() {
            this.dragEvent.isEnter = false;
        },

        onDragEndDelivery() {
            this.dragEvent.isStart = false;
            this.dragEvent.isEnter = false;
        }
    },
    mounted() {
        this.updateDeliveries();
    }
}
</script>

<style>

</style>